package com.test;

import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;
import org.drools.runtime.rule.FactHandle;
import org.drools.runtime.ObjectFilter;
import org.drools.runtime.StatefulKnowledgeSession;

import java.util.Collection;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: gaia
 * Date: 29-Oct-2009
 * Time: 16:47:42
 * To change this template use File | Settings | File Templates.
 */
public class StatusChangeWorkItemHandler implements WorkItemHandler {

    private StatefulKnowledgeSession ksession;

    public StatusChangeWorkItemHandler(StatefulKnowledgeSession ksession) {
        this.ksession = ksession;
    }

    public void executeWorkItem(WorkItem workItem, WorkItemManager workItemManager) {

        Collection<FactHandle> factHandles = ksession.getFactHandles(new ObjectFilter() {
            public boolean accept(Object object) {
                return (object instanceof SimpleFact);
            }
        });
        for (Iterator<FactHandle> iterator = factHandles.iterator(); iterator.hasNext(); ) {
            FactHandle factHandle = iterator.next();
            SimpleFact fact = (SimpleFact) ksession.getObject(factHandle);
            fact.setStatus("Error");
            ksession.update(factHandle, fact);
        }

        workItemManager.completeWorkItem(workItem.getId(), null);
    }

    public void abortWorkItem(WorkItem workItem, WorkItemManager workItemManager) {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
